module Supai
  class Address < Resource
    attr_accessor :first_name, :last_name, :line1, :line2, :line3, :city,
                  :postal_code, :region_code, :country_code

    attr_objects primary_phone: Phone, secondary_phone: Phone

    def initialize(hash)
      set_attributes(hash)
    end

    def inspect
      display = [line1, line2, line3, city, region_code, country_code].select { |str|
        str.length > 0
      }.join(", ")
      "#<#{self.class} #{display}>"
    end
  end
end
