module Supai
  class Authorization < Resource
    ENDPOINT = "/api/authorization/v7/authorization"

    attr_accessor :token, :secret, :user_id

    def self.create(authorization, api: API.new)
      response = api.request(:post, ENDPOINT, body: {}, token: authorization)
      raise response.error unless response.success?

      return self.new(response.json_body)
    end

    def initialize(hash)
      set_attributes(hash)
    end

    def authenticate_user(user_name:, password:, chain_id:, api: API.new)
      endpoint = "/api/workbenchentry/v7/chains/#{chain_id}/authentication"
      body = {
        "SessionToken": token,
        "UserName": user_name,
        "Password": password,
      }
      response = api.request(:post, endpoint, body: body, token: secret)
      raise response.error unless response.success?

      return User.new(response.json_body["User"])
    end
  end
end
