module Supai
  class UnitedPickupOrderReport < Resource
    attr_accessor :id, :status, :items_quantity, :totes_quantity, :special_instructions
    attr_objects shopper_name: Person,
                 shipping_address: Address,
                 pickup_window: PickupWindow

    def self.endpoint(chain_id:, store_id:, order_id:)
      "/api/ordermanagement/v7/chains/#{chain_id}/stores/#{store_id}/orders/#{order_id}/unitedpickuporderreport"
    end

    def self.get(chain_id:, store_id:, order_id:, params: {}, token:, api: API.new)
      response = api.request(
        :get,
        endpoint(chain_id: chain_id, store_id: store_id, order_id: order_id),
        params: params,
        headers: { accept: "application/vnd.mywebgrocer.mgmt-united-order-report+json" },
        token: token,
      )
      raise response.error unless response.success?

      UnitedPickupOrderReport.new(response.json_body)
    end

    def initialize(hash)
      set_attributes(hash)
    end
  end
end
